%Ground Motion Model Demo 2
clc
clear all
disp("地震动预测模型程序包 V1.0")
%Assign Input
MW=3;%  MW：Moment Magnitude
R=100;% R:Hypdis(km)
Vs30=2500;% Equivalent shear wave velocity with 30m depth(Vs30)(m/s)
TOF='TF';% Type of fault：'Thrust Fault(TF)','Thrust Slip(TS)','Strike-Slip(SS)',...
         %' Normal Slip(NS)','Normal Fault(NF)','Unknown(U)'
MORA='M';% MorA: 'M','A'

% calculate predicted value using GMM
[Y,tau,phi]=Ground_Motion_Model_Vs30(MW,R,Vs30,TOF,MORA);

% result postprocessing
Sa=Y(1:21);tau_Sa=tau(1:21);phi_Sa=phi(1:21);
PGA=Y(22);tau_PGA=tau(22);phi_PGA=phi(22);
PGV=Y(23);tau_PGV=tau(23);phi_PGV=phi(23);

%Print in file
file='IM_predicted.dat';
fid=fopen(file,"w");
T=[0.01,0.02,0.03,0.05,0.075,0.1,0.15,0.2,0.25,0.3,0.4,0.5,0.75,1.0,  ...
           1.5,2.0,3.0,4.0,5.0,7.5,10.0];
fprintf(fid,'Mw=%2.1f  R=%4.1fkm  Vs30=%f \n',MW,R,Vs30);
fprintf(fid,'Type of fault=%s  MorA=%s \n',TOF,MORA);
fprintf(fid,'\n');
fprintf(fid,'IM ,predicted-value, tau, phi\n');
fprintf(fid,'PGA(g)  ,%9.4f, %9.4f, %9.4f\n',PGA,tau_PGA,phi_PGA);
fprintf(fid,'PGV(cm/s)    ,%9.4f, %9.4f, %9.4f\n',PGV,tau_PGV,phi_PGV);
for i=1:21
    fprintf(fid,'Sa(T=%5.2fs) ,%9.4f, %9.4f, %9.4f \n',T(i),Sa(i),tau_Sa(i),phi_Sa(i));
end
fclose all;

%plot reponse spectrum
plot(T,Sa,'linewidth',3,'Color','red');

xlabel('Period T(s)');
ylabel('PSA(cm/s^2)');
title('Response Spectrum Predicted Value');
set(gcf,'unit','inches','position',[5 3 6 5]);
set(gca,'LooseInset',[0.13, 0.11,0.095,0.075]);
set(gca,'linewidth',2.0,'fontsize',20,'fontname','Times New Roman')
set(gcf,'Color',[1.0,1.0,1.0]);
set(gca,'Xlim',[0.01 10]);
set(gca,'XScale','log');
set(gca,'YScale','log');

print(gcf,'-dpng','-image','-r300','Response Spectrum');